layui.define(['jquery', 'laydate', 'formUtils'], function(exports) {
    var $ = layui.jquery;
    var laydate = layui.laydate;
    var utils = layui.formUtils;
    var formField = layui.formField;

    var HTML_ARRAY = [
        '<div id="{0}Box" class="layui-form-item {2}"  data-id="{0}" data-tag="{1}" data-index="{3}">',
        '   <label class="layui-form-label {0}" style="width: {3}px;"><span style="color:red;">{2}</span>{1}:</label>',
        '   <div id="{2}Block" class="layui-input-block" style="width:calc({0} - {1}px);margin-left: {1}px;">',
        '       <input id="{0}" name="{0}" lay-verify="{4}" class="layui-input icon-date widget-date {2}" style="line-height: 40px;{2}">',
        '   </div>',
        '</div>'
    ];

    var date = {
        /**
         * 根据json对象生成html对象
         * @param {object} json
         * @param {boolean} selected true 表示选择当前
         * */
        render: function (json, selected) {
            if (selected === undefined) {
                selected = false;
            }
            var _disabledClass = json.disabled ? ' layui-disabled' : '';
            var _disabledStyle = json.disabled ? ' pointer-events: none;' : '';
            var _required = json.required ? 'required' : '';
            var _html = HTML_ARRAY[0].format(json.id, json.tag, selected ? 'active' : '', json.index);
            _html += HTML_ARRAY[1].format(json.required ? 'layui-form-required' : '', json.label, json.required ? '*' : '', json.labelWidth);
            _html += HTML_ARRAY[2].format(json.width, json.labelWidth, json.id);
            _html += HTML_ARRAY[3].format(json.id, json.tag, _disabledClass, _disabledStyle, _required);
            _html += HTML_ARRAY[4];
            _html += HTML_ARRAY[5];
            return _html;
        },
        update: function (json) {
            var _disabledClass = json.disabled ? ' layui-disabled' : '';
            var _disabledStyle = json.disabled ? ' pointer-events: none;' : '';
            var _required = json.required ? 'required' : '';
            var $block = $('#' + json.id + 'Box .layui-input-block');
            var $label = $('#' + json.id + 'Box .layui-form-label');
            $block.empty();
            $label.empty();
            $block.css("margin-left", json.labelWidth);
            $label.css("width", json.labelWidth);
            if (json.required) {
                $label.append('<span style="color:red;">*</span>');
            }
            $label.append(json.label + ":");
            $block.css({
                width: 'calc({0} - {1}px)'.format(json.width, json.labelWidth)
            });
            var _html = HTML_ARRAY[3].format(json.id, json.tag, _disabledClass, _disabledStyle, _required);
            $block.append(_html);
            laydate.render({
                elem: '#' + json.tag + json.id,
                btns: ['confirm'],
                type: json.datetype,
                format: json.dateformat,
                value: json.dateDefaultValue,
                min: json.dataMinValue,
                max: json.dataMaxValue,
            });
        },
        /* 获取对象 */
        jsonData: function (id, index, columncount) {
            //分配一个新的ID
            var _json = JSON.parse(JSON.stringify(formField.date));
            _json.id = id == undefined ? utils.guid() : id;
            _json.index = index;
            return _json;
        },
        /* 根据 json 对象显示对应的属性 */
        property: function (json) {
            $('#columnProperty').empty();
            var _html = '';
            _html = utils.renderCommonProperty(json); //获取通用属性HTML字符串
            //处理特殊字符串
            for (var key in json) {
                if (key === 'index') {
                    continue;
                }
            }
            $('#columnProperty').append(_html);
        },
        componentRender: function(item) {
            laydate.render({
                elem: '#' + item.tag + item.id,
                type: item.datetype,
                format: item.dateformat,
                value: item.dateDefaultValue,
                min: item.dataMinValue,
                max: item.dataMaxValue,
            });
        },
    };

    exports('date', date);
});